diff --git a/src/main/java/net/minecraft/core/entity/player/Player.java b/src/main/java/net/minecraft/core/entity/player/Player.java
index 5f539bfbb..b49898282 100644
--- a/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -60,6 +60,7 @@ import net.minecraft.core.player.inventory.menu.AbstractContainerMenu;
 import net.minecraft.core.player.inventory.menu.InventoryMenu;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.Dimension;
@@ -112,6 +113,7 @@ public abstract class Player extends Mob
     public int timeUntilPortal;
     protected boolean inPortal;
     public int portalID;
+    public DyeColor portalColor;
     public float timeInPortal;
     public float prevTimeInPortal;
     private final int damageRemainder;
@@ -1477,7 +1479,7 @@ public abstract class Player extends Mob
     }
 
     @Override
-	public void handlePortal(int portalTileId)
+	public void handlePortal(int portalBlockId, DyeColor portalColor)
     {
         if(timeUntilPortal > 0)
         {
@@ -1485,7 +1487,8 @@ public abstract class Player extends Mob
         }
         else
         {
-        	this.portalID = portalTileId;
+        	this.portalID = portalBlockId;
+            this.portalColor = portalColor;
             inPortal = true;
         }
     }
diff --git a/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectile.java b/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectile.java
index 13cd620fc..4cd0e03ed 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectile.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectile.java
@@ -274,7 +274,7 @@ public class ArrowProjectile extends Projectile
         {
         	player.inventory.insertItem(stack, true);
         	if(stack.stackSize <= 0) {
-                world.playSoundAtEntity(player, this, "random.pop", 0.2F, ((random.nextFloat() - random.nextFloat()) * 0.7F + 1.0F) * 2.0F);
+                world.playSoundAtEntity(player, this, "item.pickup", 1F, ((random.nextFloat() - random.nextFloat()) * 0.7F + 1.0F) * 4.0F);
                 player.onItemPickup(this, stack);
                 remove();
         	}
diff --git a/src/main/java/net/minecraft/core/net/command/helpers/ItemStackArgumentParser.java b/src/main/java/net/minecraft/core/net/command/helpers/ItemStackArgumentParser.java
index 26c7785d0..c1ee9cf69 100644
--- a/src/main/java/net/minecraft/core/net/command/helpers/ItemStackArgumentParser.java
+++ b/src/main/java/net/minecraft/core/net/command/helpers/ItemStackArgumentParser.java
@@ -66,7 +66,6 @@ public class ItemStackArgumentParser extends ArgumentParser {
             builder.append(reader.read());
         }
         String string = builder.toString();
-        System.out.println(string);
         for (Item itemInList : Item.itemsList) {
             if (itemInList == null) continue;
             if (CommandHelper.matchesNamespaceId(itemInList.namespaceID, string)) {
diff --git a/src/main/java/net/minecraft/core/world/PortalHandler.java b/src/main/java/net/minecraft/core/world/PortalHandler.java
index 3d70844e4..a3d34d141 100644
--- a/src/main/java/net/minecraft/core/world/PortalHandler.java
+++ b/src/main/java/net/minecraft/core/world/PortalHandler.java
@@ -1,10 +1,12 @@
 package net.minecraft.core.world;
 
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.PortalBlock;
 import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -20,15 +22,15 @@ public class PortalHandler
         rand = new Random();
     }
 
-    public void teleportEntity(World world, Entity entity, Dimension oldDim, Dimension newDim)
+    public void teleportEntity(World world, Entity entity, @Nullable DyeColor portalColor, Dimension oldDim, Dimension newDim)
     {
-        if (!attemptToTeleportToClosestPortal(world, entity, oldDim, newDim)) {
-            generatePortal(world, entity, oldDim, newDim);
-            attemptToTeleportToClosestPortal(world, entity, oldDim, newDim);
+        if (!attemptToTeleportToClosestPortal(world, entity, portalColor, oldDim, newDim)) {
+            generatePortal(world, entity, portalColor, oldDim, newDim);
+            attemptToTeleportToClosestPortal(world, entity, portalColor, oldDim, newDim);
         }
     }
 
-    public boolean attemptToTeleportToClosestPortal(World world, Entity entity, Dimension oldDim, Dimension newDim)
+    public boolean attemptToTeleportToClosestPortal(World world, Entity entity, @Nullable DyeColor portalColor, Dimension oldDim, Dimension newDim)
     {
         int searchRadius = 128;
         double lowestEntityDistanceSquared = -1D;
@@ -46,9 +48,13 @@ public class PortalHandler
         int oldDimRangeY = oldWorldType.getMaxY() - oldWorldType.getMinY();
         entityPosYScaled -= oldWorldType.getMinY();
         entityPosYScaled /= oldDimRangeY; // Now 0.0 to 1.0
-        int newDimRangeY = newWorldType.getMaxY() - newWorldType.getMinY();
+        int minY = newWorldType.getMinY();
+        if (newDim == Dimension.NETHER) {
+            minY = 128;
+        }
+        int newDimRangeY = newWorldType.getMaxY() - minY;
         entityPosYScaled *= newDimRangeY;
-        entityPosYScaled += newWorldType.getMinY(); // Now newDim minY to newDim maxY
+        entityPosYScaled += minY; // Now newDim minY to newDim maxY
         
         if (newDim.homeDim == null)
         {
@@ -66,12 +72,16 @@ public class PortalHandler
             for(int dz = entityBlockZ - searchRadius; dz <= entityBlockZ + searchRadius; dz++)
             {
                 double zEntityDistance = ((double)dz + 0.5D) - entity.z;
-                for(int dy = newWorldType.getMaxY() - 1; dy >= newWorldType.getMinY(); dy--)
+                for(int dy = newWorldType.getMaxY() - 1; dy >= minY; dy--)
                 {
                     if(world.getBlockId(dx, dy, dz) != targetPortalId)
                     {
                         continue;
                     }
+
+                    if (portalColor != null && targetPortalId > 0 && ((PortalBlock)Block.getBlock(targetPortalId)).getColor(world, dx, dy, dz) != portalColor) {
+                        continue;
+                    }
                     
                     // Find the bottom portal block of the portal
                     for(; world.getBlockId(dx, dy - 1, dz) == targetPortalId; dy--);
@@ -125,7 +135,7 @@ public class PortalHandler
         }
     }
 
-    public boolean generatePortal(World world, Entity entity, Dimension oldDim, Dimension newDim)
+    public boolean generatePortal(World world, Entity entity, @Nullable DyeColor portalColor, Dimension oldDim, Dimension newDim)
     {
         WorldType oldWorldType = oldDim.getDimensionData(world).getWorldType();
         WorldType newWorldType = newDim.getDimensionData(world).getWorldType();
@@ -134,9 +144,15 @@ public class PortalHandler
         int oldDimRangeY = oldWorldType.getMaxY() - oldWorldType.getMinY();
         entityPosYScaled -= oldWorldType.getMinY();
         entityPosYScaled /= oldDimRangeY; // Now 0.0 to 1.0
-        int newDimRangeY = newWorldType.getMaxY() - newWorldType.getMinY();
+        int minY = newWorldType.getMinY();
+        if (newDim == Dimension.NETHER) {
+            minY = 128;
+        }
+        int newDimRangeY = newWorldType.getMaxY() - minY;
         entityPosYScaled *= newDimRangeY;
-        entityPosYScaled += newWorldType.getMinY(); // Now newDim minY to newDim maxY
+        entityPosYScaled += minY; // Now newDim minY to newDim maxY
+
+
 
         byte portalSearchRadius = 16;
         double lowestEntityDistance = -1D;
@@ -168,7 +184,7 @@ public class PortalHandler
             for(int dz = blockZ - portalSearchRadius; dz <= blockZ + portalSearchRadius; dz++)
             {
                 double zEntityDistance = ((double)dz + 0.5D) - entity.z;
-                for(int dy = newWorldType.getMaxY() - 1; dy >= newWorldType.getMinY(); dy--)
+                for(int dy = newWorldType.getMaxY() - 1; dy >= minY; dy--)
                 {
                     if(!world.isAirBlock(dx, dy, dz))
                     {
@@ -230,7 +246,7 @@ label0:
                 for(int dz = blockZ - portalSearchRadius; dz <= blockZ + portalSearchRadius; dz++)
                 {
                     double entityDistanceZ = ((double)dz + 0.5D) - entity.z;
-                    for(int dy = newWorldType.getMaxY() - 1; dy >= newWorldType.getMinY(); dy--)
+                    for(int dy = newWorldType.getMaxY() - 1; dy >= minY; dy--)
                     {
                         if(!world.isAirBlock(dx, dy, dz))
                         {
@@ -324,7 +340,7 @@ label1:
 
             }
             
-            ((PortalBlock)Block.blocksList[targetPortalId]).tryToCreatePortal(world, portalX,  portalY,  portalZ);
+            ((PortalBlock)Block.blocksList[targetPortalId]).tryToCreatePortal(world, portalX,  portalY,  portalZ, portalColor);
 
             world.noNeighborUpdate = false;
             for(int k6 = 0; k6 < 4; k6++)
diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index 2a9e7d557..22077df14 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -2341,10 +2341,15 @@ public class World implements WorldSource {
     public void onUnload()
     {
         // Unloads all entities
-        updateEntities();
-
-        loadedEntityList.clear();
-        unloadedEntityList.clear();
+        try {
+            updateEntities();
+        } catch (Throwable t) {
+            LOGGER.error("Unhandled exception while unloading all entities!", t);
+            throw t;
+        } finally {
+            loadedEntityList.clear();
+            unloadedEntityList.clear();
+        }
     }
 
     public void saveWorldIndirectly(ProgressListener iprogressupdate)
@@ -2467,45 +2472,45 @@ public class World implements WorldSource {
 
 	public void tick() {
         Debug.push("misc");
-		immediatelyUpdatedPositions.clear();
+        immediatelyUpdatedPositions.clear();
         Debug.change("weather");
-		weatherManager.tick();
+        weatherManager.tick();
         Debug.change("misc");
-		updateSleepingPlayers();
+        updateSleepingPlayers();
         Debug.change("spawning");
         // TODO mob spawning seems to be the cause of many lag spikes, specifically the checks for is a mob is allowed to spawn at a certain xyz position seem to be the worst offenders
-		SpawnerMobs.performSpawning(this, getSpawnerConfig());
+        SpawnerMobs.performSpawning(this, getSpawnerConfig());
         Debug.change("chunk");
-		chunkProvider.tick();
+        chunkProvider.tick();
 
         Debug.change("autosave");
-		int autosaveTimeInSeconds = Global.accessor.getAutosaveTimer();
-		int autosaveTimeInTicks = (autosaveTimeInSeconds * 20);
+        int autosaveTimeInSeconds = Global.accessor.getAutosaveTimer();
+        int autosaveTimeInTicks = (autosaveTimeInSeconds * 20);
 
-		AUTOSAVE = autosaveTimeInTicks != 0;
-		if(AUTOSAVE && runtime % (long) autosaveTimeInTicks == 0L) {
-			saveWorld(false, null, true);
-		}
+        AUTOSAVE = autosaveTimeInTicks != 0;
+        if(AUTOSAVE && runtime % (long) autosaveTimeInTicks == 0L) {
+            saveWorld(false, null, true);
+        }
 
         Debug.change("misc");
-		if(getGameRuleValue(GameRules.DO_DAY_CYCLE)) {
-			levelData.setWorldTime(levelData.getWorldTime() + 1L);
-		}
+        if(getGameRuleValue(GameRules.DO_DAY_CYCLE)) {
+            levelData.setWorldTime(levelData.getWorldTime() + 1L);
+        }
 
-		runtime++;
+        runtime++;
 
-		tickUpdates(false);
+        tickUpdates(false);
         Debug.change("blocks&cavesSounds");
-		updateBlocksAndPlayCaveSounds();
+        updateBlocksAndPlayCaveSounds();
         Debug.change("season&light");
-		updateSeasonAndLight();
+        updateSeasonAndLight();
         if(rainbowTicks > 0)
         {
             rainbowTicks--;
         }
         Debug.pop();
 	}
-	
+
 	public void updateSeasonAndLight() {
 		boolean seasonChanged = false;
 		boolean lightChanged = false;
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkPosition.java b/src/main/java/net/minecraft/core/world/chunk/ChunkPosition.java
index 7a669f107..4af851078 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkPosition.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkPosition.java
@@ -27,8 +27,10 @@ public class ChunkPosition {
     }
 
     @Override
-	public int hashCode()
-    {
-        return x * 0x88f9fa + y * 0xef88b + z;
+    public int hashCode() {
+        int result = x;
+        result = 31 * result + y;
+        result = 31 * result + z;
+        return result;
     }
 }
diff --git a/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index 755f6fb77..03b35a1b8 100644
--- a/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -288,6 +288,14 @@ class WorkbenchGenerator {
             .addInput('X', Blocks.SAND)
             .create("pebbles_to_limestone", new ItemStack(Blocks.COBBLE_LIMESTONE, 2));
 
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "#X",
+                "X#")
+            .addInput('#', Items.AMMO_PEBBLE)
+            .addInput('X', Blocks.ICE)
+            .create("pebbles_to_permafrost", new ItemStack(Blocks.COBBLE_PERMAFROST, 2));
+
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
                 "#X",
@@ -298,11 +306,10 @@ class WorkbenchGenerator {
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
-                "FPF",
-                "PFP",
-                "FPF")
-            .addInput('F', Items.FLINT)
-            .addInput('P', Items.AMMO_PEBBLE)
+                "#X",
+                "X#")
+            .addInput('#', Items.AMMO_PEBBLE)
+            .addInput('X', Items.FLINT)
             .create("gravel_from_flint_and_pebbles", Blocks.GRAVEL.getDefaultStack());
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
diff --git a/src/main/java/net/minecraft/server/MinecraftServer.java b/src/main/java/net/minecraft/server/MinecraftServer.java
index e21991249..d2a22376b 100644
--- a/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -652,9 +652,25 @@ public class MinecraftServer
             {
                 playerList.sendPacketToAllPlayersInDimension(new SetTimePacket(worldServer.getWorldTime()), worldServer.dimension.id);
             }
-            worldServer.tick();
-            while (worldServer.updatingLighting()) ;
-            worldServer.updateEntities();
+            try {
+                worldServer.tick();
+            }  catch (Throwable t) {
+                LOGGER.error("Unhandled exception while ticking dimension {}!", worldServer.dimension, t);
+                initiateShutdown();
+                break;
+            }
+            try {
+                while (worldServer.updatingLighting()) ;
+            } catch (Throwable t) {
+                LOGGER.error("Unhandled exception while updating lighting in dimension {}!", worldServer.dimension, t);
+            }
+            try {
+                worldServer.updateEntities();
+            }  catch (Throwable t) {
+                LOGGER.error("Unhandled exception while updating entities in dimension {}!", worldServer.dimension, t);
+                initiateShutdown();
+                break;
+            }
         }
 
         networkServer.handleNetworkListenThread();
diff --git a/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java b/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java
index 0b1b443c2..6c1b5e3c8 100644
--- a/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java
+++ b/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java
@@ -323,11 +323,11 @@ public class ServerPlayer extends Player implements ContainerListener {
                         timeUntilPortal = 10;
                         if (dimension == targetDim)
                         {
-                            mcServer.playerList.sendPlayerToOtherDimension(this, 0, true);
+                            mcServer.playerList.sendPlayerToOtherDimension(this, 0, portalColor, true);
                         }
                         else
                         {
-                            mcServer.playerList.sendPlayerToOtherDimension(this, targetDim, true);
+                            mcServer.playerList.sendPlayerToOtherDimension(this, targetDim, portalColor, true);
                         }
                     }
                 }
@@ -509,6 +509,7 @@ public class ServerPlayer extends Player implements ContainerListener {
     {
         getNextWindowId();
         playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, ContainerOpenPacket.TYPE_CRAFTING, "Crafting", 9));
+        craftingInventory.onCraftGuiClosed(this);
         craftingInventory = new CraftingMenu(inventory, world, x, y, z);
         craftingInventory.containerId = currentWindowId;
         craftingInventory.addSlotListener(this);
@@ -526,6 +527,7 @@ public class ServerPlayer extends Player implements ContainerListener {
         getNextWindowId();
         ServerPacketHandler.LOGGER.info("{} interacted with chest at ({}, {}, {})", username, x, y, z);
         playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, ContainerOpenPacket.TYPE_GENERIC_CONTAINER, container.getName(), container.getContainerSize()));
+        craftingInventory.onCraftGuiClosed(this);
         craftingInventory = new ContainerMenu(inventory, container);
         craftingInventory.containerId = currentWindowId;
         craftingInventory.addSlotListener(this);
@@ -543,7 +545,7 @@ public class ServerPlayer extends Player implements ContainerListener {
         {
             playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, ContainerOpenPacket.TYPE_FURNACE, blockEntity.getName(), blockEntity.getContainerSize()));
         }
-
+        craftingInventory.onCraftGuiClosed(this);
         craftingInventory = new FurnaceMenu(inventory, blockEntity);
         craftingInventory.containerId = currentWindowId;
         craftingInventory.addSlotListener(this);
@@ -554,6 +556,7 @@ public class ServerPlayer extends Player implements ContainerListener {
     {
         getNextWindowId();
         playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, ContainerOpenPacket.TYPE_DISPENSER, blockEntity.getName(), blockEntity.getContainerSize()));
+        craftingInventory.onCraftGuiClosed(this);
         craftingInventory = new TrapMenu(inventory, blockEntity);
         craftingInventory.containerId = currentWindowId;
         craftingInventory.addSlotListener(this);
@@ -564,6 +567,7 @@ public class ServerPlayer extends Player implements ContainerListener {
     {
         getNextWindowId();
         playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, ContainerOpenPacket.TYPE_ACTIVATOR, blockEntity.getName(), blockEntity.getContainerSize()));
+        craftingInventory.onCraftGuiClosed(this);
         craftingInventory = new ActivatorMenu(inventory, blockEntity);
         craftingInventory.containerId = currentWindowId;
         craftingInventory.addSlotListener(this);
@@ -575,6 +579,7 @@ public class ServerPlayer extends Player implements ContainerListener {
     {
         getNextWindowId();
         playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, ContainerOpenPacket.TYPE_TROMMEL, blockEntity.getName(), blockEntity.getContainerSize()));
+        craftingInventory.onCraftGuiClosed(this);
         craftingInventory = new TrommelMenu(inventory, blockEntity);
         craftingInventory.containerId = currentWindowId;
         craftingInventory.addSlotListener(this);
@@ -585,6 +590,7 @@ public class ServerPlayer extends Player implements ContainerListener {
     {
         getNextWindowId();
         playerNetServerHandler.sendPacket(new FlagOpenPacket(currentWindowId, blockEntity.x, blockEntity.y, blockEntity.z));
+        craftingInventory.onCraftGuiClosed(this);
         craftingInventory = new FlagMenu(inventory, blockEntity);
         craftingInventory.containerId = currentWindowId;
         craftingInventory.addSlotListener(this);
@@ -594,6 +600,7 @@ public class ServerPlayer extends Player implements ContainerListener {
     {
         getNextWindowId();
 
+        craftingInventory.onCraftGuiClosed(this);
         craftingInventory = new GuidebookMenu();
         craftingInventory.containerId = currentWindowId;
         craftingInventory.addSlotListener(this);
diff --git a/src/main/java/net/minecraft/server/net/PlayerList.java b/src/main/java/net/minecraft/server/net/PlayerList.java
index 2ca164366..b713dbbbd 100644
--- a/src/main/java/net/minecraft/server/net/PlayerList.java
+++ b/src/main/java/net/minecraft/server/net/PlayerList.java
@@ -5,6 +5,7 @@ import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.server.entity.player.ServerPlayer;
@@ -247,7 +248,7 @@ public class PlayerList
         return newPlayer;
     }
 
-    public void sendPlayerToOtherDimension(ServerPlayer serverPlayer, int targetDim, boolean generatePortal)
+    public void sendPlayerToOtherDimension(ServerPlayer serverPlayer, int targetDim, DyeColor portalColor, boolean generatePortal)
     {
         WorldServer worldserver = server.getDimensionWorld(serverPlayer.dimension);
         Dimension lastDim = Dimension.getDimensionList().get(serverPlayer.dimension);
@@ -288,7 +289,7 @@ public class PlayerList
             worldserver1.updateEntityWithOptionalForce(serverPlayer, false);
             if (generatePortal){
                 worldserver1.chunkProviderServer.chunkLoadOverride = true;
-                (new PortalHandler()).teleportEntity(worldserver1, serverPlayer, lastDim, newDim);
+                (new PortalHandler()).teleportEntity(worldserver1, serverPlayer, portalColor, lastDim, newDim);
                 worldserver1.chunkProviderServer.chunkLoadOverride = false;
             }
         }
diff --git a/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java b/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
index 399b3dc81..17d60c366 100644
--- a/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
+++ b/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
@@ -98,7 +98,7 @@ public class ConsoleCommandSource implements CommandSource, IServerCommandSource
     @Override
     public void movePlayerToDimension(Player player, int dimension) {
         if (player instanceof ServerPlayer)
-            this.server.playerList.sendPlayerToOtherDimension((ServerPlayer) player, dimension, false);
+            this.server.playerList.sendPlayerToOtherDimension((ServerPlayer) player, dimension, null, false);
         else throw new IllegalStateException("Player is not an instance of ServerPlayer");
     }
 
diff --git a/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java b/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
index ba637d1ba..57d568ea1 100644
--- a/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
+++ b/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
@@ -99,7 +99,7 @@ public class ServerCommandSource implements CommandSource, IServerCommandSource
     @Override
     public void movePlayerToDimension(Player player, int dimension) {
         if (player instanceof ServerPlayer)
-            this.server.playerList.sendPlayerToOtherDimension((ServerPlayer) player, dimension, false);
+            this.server.playerList.sendPlayerToOtherDimension((ServerPlayer) player, dimension, null, false);
         else throw new IllegalStateException("Player is not an instance of ServerPlayer");
     }
 
diff --git a/src/main/resources/assets/minecraft/textures/block/portal_nether/black.png.mcmeta b/src/main/resources/assets/minecraft/textures/block/portal_nether/black.png.mcmeta
new file mode 100644
index 000000000..4f0718ac9
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/block/portal_nether/black.png.mcmeta
@@ -0,0 +1,3 @@
+{
+  "animation": {}
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/block/portal_nether/blue.png.mcmeta b/src/main/resources/assets/minecraft/textures/block/portal_nether/blue.png.mcmeta
new file mode 100644
index 000000000..4f0718ac9
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/block/portal_nether/blue.png.mcmeta
@@ -0,0 +1,3 @@
+{
+  "animation": {}
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/block/portal_nether/brown.png.mcmeta b/src/main/resources/assets/minecraft/textures/block/portal_nether/brown.png.mcmeta
new file mode 100644
index 000000000..4f0718ac9
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/block/portal_nether/brown.png.mcmeta
@@ -0,0 +1,3 @@
+{
+  "animation": {}
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/block/portal_nether/cyan.png.mcmeta b/src/main/resources/assets/minecraft/textures/block/portal_nether/cyan.png.mcmeta
new file mode 100644
index 000000000..4f0718ac9
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/block/portal_nether/cyan.png.mcmeta
@@ -0,0 +1,3 @@
+{
+  "animation": {}
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/block/portal_nether/gray.png.mcmeta b/src/main/resources/assets/minecraft/textures/block/portal_nether/gray.png.mcmeta
new file mode 100644
index 000000000..4f0718ac9
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/block/portal_nether/gray.png.mcmeta
@@ -0,0 +1,3 @@
+{
+  "animation": {}
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/block/portal_nether/green.png.mcmeta b/src/main/resources/assets/minecraft/textures/block/portal_nether/green.png.mcmeta
new file mode 100644
index 000000000..4f0718ac9
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/block/portal_nether/green.png.mcmeta
@@ -0,0 +1,3 @@
+{
+  "animation": {}
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/block/portal_nether/lightblue.png.mcmeta b/src/main/resources/assets/minecraft/textures/block/portal_nether/lightblue.png.mcmeta
new file mode 100644
index 000000000..4f0718ac9
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/block/portal_nether/lightblue.png.mcmeta
@@ -0,0 +1,3 @@
+{
+  "animation": {}
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/block/portal_nether/lime.png.mcmeta b/src/main/resources/assets/minecraft/textures/block/portal_nether/lime.png.mcmeta
new file mode 100644
index 000000000..4f0718ac9
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/block/portal_nether/lime.png.mcmeta
@@ -0,0 +1,3 @@
+{
+  "animation": {}
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/block/portal_nether/magenta.png.mcmeta b/src/main/resources/assets/minecraft/textures/block/portal_nether/magenta.png.mcmeta
new file mode 100644
index 000000000..4f0718ac9
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/block/portal_nether/magenta.png.mcmeta
@@ -0,0 +1,3 @@
+{
+  "animation": {}
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/block/portal_nether/orange.png.mcmeta b/src/main/resources/assets/minecraft/textures/block/portal_nether/orange.png.mcmeta
new file mode 100644
index 000000000..4f0718ac9
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/block/portal_nether/orange.png.mcmeta
@@ -0,0 +1,3 @@
+{
+  "animation": {}
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/block/portal_nether/pink.png.mcmeta b/src/main/resources/assets/minecraft/textures/block/portal_nether/pink.png.mcmeta
new file mode 100644
index 000000000..4f0718ac9
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/block/portal_nether/pink.png.mcmeta
@@ -0,0 +1,3 @@
+{
+  "animation": {}
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/block/portal_nether/purple.png.mcmeta b/src/main/resources/assets/minecraft/textures/block/portal_nether/purple.png.mcmeta
new file mode 100644
index 000000000..4f0718ac9
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/block/portal_nether/purple.png.mcmeta
@@ -0,0 +1,3 @@
+{
+  "animation": {}
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/block/portal_nether/red.png.mcmeta b/src/main/resources/assets/minecraft/textures/block/portal_nether/red.png.mcmeta
new file mode 100644
index 000000000..4f0718ac9
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/block/portal_nether/red.png.mcmeta
@@ -0,0 +1,3 @@
+{
+  "animation": {}
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/block/portal_nether/silver.png.mcmeta b/src/main/resources/assets/minecraft/textures/block/portal_nether/silver.png.mcmeta
new file mode 100644
index 000000000..4f0718ac9
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/block/portal_nether/silver.png.mcmeta
@@ -0,0 +1,3 @@
+{
+  "animation": {}
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/block/portal_nether/white.png.mcmeta b/src/main/resources/assets/minecraft/textures/block/portal_nether/white.png.mcmeta
new file mode 100644
index 000000000..4f0718ac9
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/block/portal_nether/white.png.mcmeta
@@ -0,0 +1,3 @@
+{
+  "animation": {}
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/block/portal_nether/yellow.png.mcmeta b/src/main/resources/assets/minecraft/textures/block/portal_nether/yellow.png.mcmeta
new file mode 100644
index 000000000..4f0718ac9
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/block/portal_nether/yellow.png.mcmeta
@@ -0,0 +1,3 @@
+{
+  "animation": {}
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/block/portal_paradise/black.png.mcmeta b/src/main/resources/assets/minecraft/textures/block/portal_paradise/black.png.mcmeta
new file mode 100644
index 000000000..4f0718ac9
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/block/portal_paradise/black.png.mcmeta
@@ -0,0 +1,3 @@
+{
+  "animation": {}
+}
\ No newline at end of file
